=== requirements.txt ===
#This is a python requirements file
#used by pip for ADIOS Python package installation.
#Note that on HPC systems you likely want to build
#mpi4py rather than pip installing it.

numpy>=1.19
mpi4py>=3.0.3
